program ScreenSaver;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// minais - MNOgl component collection --> http://www.minais.at
// Code from www.community.borland.com
// by Borland Developer Support Staff Technical Information Database
// TI4534D.txt
// http://community.borland.com/article/0,1410,19534,00.html
//
//
// ScreenSaver sample project:
//
// 1. Build the project
// 2. Copy file ScreenSaver.scr to your windows sytem32 directory
// 3. Change to Display properties --> Screensaver
// 4. Select ScreenSaver from Combobox and say TEST
// 5. Done.
//
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

uses
  Forms,
  SysUtils,
  Windows,
  Graphics,
  Classes,
  ScreenSaver_main in 'ScreenSaver_main.pas' {Setup},
  ScreenSaver_ssaver in 'ScreenSaver_ssaver.pas' {Scrn};


{$E SCR}
{$R *.RES}

var
  MySem       : THandle;
  Arg1,
  Arg2        : String;
  DemoWnd     : HWnd;
  MyRect      : TRect;
  MyCanvas    : TCanvas;
  x, y,
  dx, dy      : Integer;
  MyBkgBitmap,
  InMemBitmap : TBitmap;
  ScrWidth,
  ScrHeight   : Integer;
  SysDir      : String;
  NewLen      : Integer;
  MyMod       : THandle;
  PwdFunc     : function (a : PChar; ParentHandle : THandle; b, c : Integer) :
                    Integer; stdcall;
begin
  Arg1 := UpperCase(ParamStr(1));
  Arg2 := UpperCase(ParamStr(2));

  if (Copy(Arg1,1,2) = '/A') or (Copy(Arg1,1,2) = '-A') or
     (Copy(Arg1,1,1) = 'A') then
    SSMode := ssSetPwd;

  if (Copy(Arg1,1,2) = '/P') or (Copy(Arg1,1,2) = '-P') or
     (Copy(Arg1,1,1) = 'P') then
    SSMode := ssPreview;

  if (Copy(Arg1,1,2) = '/C') or (Copy(Arg1,1,2) = '-C') or
     (Copy(Arg1,1,1) = 'C') or (Arg1 = '') then
    SSMode := ssConfig;

  if SSMode = ssSetPwd then begin
    SetLength(SysDir,MAX_PATH);
    NewLen := GetSystemDirectory(PChar(SysDir),MAX_PATH);
    SetLength(SysDir,NewLen);
    if (Length(SysDir) > 0) and (SysDir[Length(SysDir)] <> '\') then
      SysDir := SysDir+'\';
    MyMod := LoadLibrary(PChar(SysDir+'MPR.DLL'));
    if MyMod <> 0 then begin
      PwdFunc := GetProcAddress(MyMod,'PwdChangePasswordA');
      if Assigned(PwdFunc) then
        PwdFunc('SCRSAVE',StrToInt(Arg2),0,0);
      FreeLibrary(MyMod);
    end;
    Halt;
  end;

  MySem := CreateSemaphore(nil,0,1,'SimpleSaverSemaphore');
  if ((MySem <> 0) and (GetLastError = ERROR_ALREADY_EXISTS)) then begin
    CloseHandle(MySem);
    Halt;
  end;

  Application.Initialize;

  if SSMode = ssPreview then begin
    DemoWnd := StrToInt(Arg2);
    while not IsWindowVisible(DemoWnd) do
      Application.ProcessMessages;
    GetWindowRect(DemoWnd,MyRect);
    ScrWidth := MyRect.Right-MyRect.Left+1;
    ScrHeight := MyRect.Bottom-MyRect.Top+1;
    MyRect := Rect(0,0,ScrWidth-1,ScrHeight-1);
    MyCanvas := TCanvas.Create;
    MyCanvas.Handle := GetDC(DemoWnd);
    MyCanvas.Pen.Color := clWhite;
    x := (ScrWidth div 2)-16;
    y := (ScrHeight div 2)-16;
    dx := 1;
    dy := 1;
    MyBkgBitmap := TBitmap.Create;
    with MyBkgBitmap do begin
      Width := ScrWidth;
      Height := ScrHeight;
    end;
    MyBkgBitmap.Canvas.FillRect(Rect(0,0,ScrWidth-1,ScrHeight-1));
    InMemBitmap := TBitmap.Create;
    with InMemBitmap do begin
      Width := ScrWidth;
      Height := ScrHeight;
    end;
    while IsWindowVisible(DemoWnd) do begin
      InMemBitmap.Canvas.CopyRect(MyRect,MyBkgBitmap.Canvas,MyRect);
      InMemBitmap.Canvas.Draw(x,y,Application.Icon);
      MyCanvas.CopyRect(MyRect,InMemBitmap.Canvas,MyRect);
      Sleep(10);
      Application.ProcessMessages;
      if (x = 0) or (x = (ScrWidth-33)) then
        dx := -dx;
      if (y = 0) or (y = (ScrHeight-33)) then
        dy := -dy;
      x := x+dx;
      y := y+dy;
    end;
    MyBkgBitmap.Free;
    InMemBitmap.Free;
    MyCanvas.Free;
    CloseHandle(MySem);
    Halt;
  end;

  if SSMode = ssConfig then begin
    Application.CreateForm(TSetup, Setup);
  end else
    Application.CreateForm(TScrn,Scrn);

  Application.Run;

  CloseHandle(MySem);
end.


